"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactD3Core = require('react-d3-core');

var _reactD3Shape = require('react-d3-shape');

var _barStack = require('./charts/barStack');

var _barStack2 = _interopRequireDefault(_barStack);

var _tooltip = require('./utils/tooltip');

var _tooltip2 = _interopRequireDefault(_tooltip);

var _focus = require('./utils/focus');

var _focus2 = _interopRequireDefault(_focus);

var _barEvt = require('./inherit/barEvt');

var _barEvt2 = _interopRequireDefault(_barEvt);

var _commonProps = require('./commonProps');

var _commonProps2 = _interopRequireDefault(_commonProps);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var BarGroupTooltip = function (_BarEvt) {
  _inherits(BarGroupTooltip, _BarEvt);

  function BarGroupTooltip(props) {
    _classCallCheck(this, BarGroupTooltip);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(BarGroupTooltip).call(this, props));
  }

  _createClass(BarGroupTooltip, [{
    key: 'render',
    value: function render() {
      var _props = this.props;
      var width = _props.width;
      var height = _props.height;


      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          _tooltip2.default,
          _extends({}, this.props, this.state),
          this.props.children
        ),
        _react2.default.createElement(_reactD3Core.Legend, this.props),
        _react2.default.createElement(
          _reactD3Shape.Chart,
          _extends({}, this.props, this.state, {
            stack: true
          }),
          _react2.default.createElement(_barStack2.default, _extends({}, this.props, this.state, {
            onClick: this.props.onClick,
            onMouseOver: this.mouseOver.bind(this),
            onMouseOut: this.mouseOut.bind(this)
          }))
        )
      );
    }
  }]);

  return BarGroupTooltip;
}(_barEvt2.default);

BarGroupTooltip.defaultProps = _commonProps2.default;
exports.default = BarGroupTooltip;
module.exports = exports['default'];