"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactD3Core = require('react-d3-core');

var _reactD3Shape = require('react-d3-shape');

var _commonProps = require('../commonProps');

var _commonProps2 = _interopRequireDefault(_commonProps);

var _tooltipUpdate = require('../utils/tooltipUpdate');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var BarGroupContainer = function (_Component) {
  _inherits(BarGroupContainer, _Component);

  function BarGroupContainer(props) {
    _classCallCheck(this, BarGroupContainer);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(BarGroupContainer).call(this, props));
  }

  _createClass(BarGroupContainer, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      return !(0, _tooltipUpdate.isTooltipUpdate)(nextProps, nextState, this);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var onMouseOver = _props.onMouseOver;
      var onMouseOut = _props.onMouseOut;
      var showXGrid = _props.showXGrid;
      var showYGrid = _props.showYGrid;


      var xgrid, ygrid;

      if (showXGrid) xgrid = _react2.default.createElement(_reactD3Core.Xgrid, this.props);
      if (showYGrid) ygrid = _react2.default.createElement(_reactD3Core.Ygrid, this.props);

      return _react2.default.createElement(
        'g',
        null,
        xgrid,
        ygrid,
        _react2.default.createElement(_reactD3Core.Xaxis, this.props),
        _react2.default.createElement(_reactD3Core.Yaxis, this.props),
        _react2.default.createElement(_reactD3Shape.BarGroup, _extends({}, this.props, {
          onMouseOver: onMouseOver,
          onMouseOut: onMouseOut
        }))
      );
    }
  }]);

  return BarGroupContainer;
}(_react.Component);

BarGroupContainer.defaultProps = _commonProps2.default;
exports.default = BarGroupContainer;
module.exports = exports['default'];